import es
import cmdlib
import popuplib
import playerlib
import vecmath
from gamethread import queue
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Universal Soccer Script"
info.version = "2.13"
info.url = "http://addons.eventscripts.com/addons/view/soccer"
info.basename = "soccer"
info.author = "chrismrulz"
es.set('uss_version', info.version)
es.makepublic('uss_version')

def optionssay(userid, args):
	popups['optionsmenu'].send(userid)

def navmenu(userid, choice, popupname):
	popups[popupname].unsend(userid)
	popups[choice.replace('goto', '')].send(userid)

def setoption(userid, choice, popupname):
	if(str(choice).startswith('goto')):
		navmenu(userid, choice, popupname)
	else:
		steamid = es.getplayersteamid(userid)
		global players
		if(steamid not in players):
			players[steamid] = {}
		players[steamid][popupname] = choice

popups = {}
popups['optionsmenu'] = popuplib.easymenu('optionsmenu', None, navmenu)
popups['optionsmenu'].settitle('Options')
popups['optionsmenu'].addoption('gotoknifemenu', 'Knifing')
popups['optionsmenu'].addoption('gotosprintmenu', 'Sprinting')
popups['optionsmenu'].addoption('gotospawnmenu', 'Spawning')

popups['knifemenu'] = popuplib.easymenu('knifemenu', None, navmenu)
popups['knifemenu'].settitle('Options>Knifing')
popups['knifemenu'].addoption('gotoknifemsgmode', 'Message Delivery')
popups['knifemenu'].addoption('gotoknifesounds', 'Warning Sounds')
popups['knifemenu'].addoption('gotooptionsmenu', 'Back..')

popups['sprintmenu'] = popuplib.easymenu('sprintmenu', None, navmenu)
popups['sprintmenu'].settitle('Options>Sprinting')
popups['sprintmenu'].addoption('gotosprintmsgs', 'Messages')
popups['sprintmenu'].addoption('gotosprintmsgmode', 'Message Delivery')
popups['sprintmenu'].addoption('gotooptionsmenu', 'Back..')

popups['spawnmenu'] = popuplib.easymenu('spawnmenu', None, navmenu)
popups['spawnmenu'].settitle('Options>Spawning')
popups['spawnmenu'].addoption('gotospawnlook', 'View Enemy Goals')
popups['spawnmenu'].addoption('gotooptionsmenu', 'Back..')

popups['knifemsgmode'] = popuplib.easymenu('knifemsgmode', None, setoption)
popups['knifemsgmode'].settitle('Options>Knifing>Message Delivery')
popups['knifemsgmode'].addoption(0, 'Popups on the left')
popups['knifemsgmode'].addoption(1, 'Popups on the bottom-center')
popups['knifemsgmode'].addoption(2, 'Chat messages')
popups['knifemsgmode'].addoption('gotoknifemenu', 'Back..')

popups['knifesounds'] = popuplib.easymenu('knifesounds', None, setoption)
popups['knifesounds'].settitle('Options>Knifing>Warning Sounds')
popups['knifesounds'].addoption(0, 'Enabled')
popups['knifesounds'].addoption(1, 'Disabled')
popups['knifesounds'].addoption(2, 'Enabled only for !knifecount')
popups['knifesounds'].addoption('gotoknifemenu', 'Back..')

popups['sprintmsgs'] = popuplib.easymenu('sprintmsgs', None, setoption)
popups['sprintmsgs'].settitle('Options>Sprinting>Messages')
popups['sprintmsgs'].addoption(0, 'Off')
popups['sprintmsgs'].addoption(1, 'Normal')
popups['sprintmsgs'].addoption(2, 'Extended')
popups['sprintmsgs'].addoption('gotosprintmenu', 'Back..')

popups['sprintmsgmode'] = popuplib.easymenu('sprintmsgmode', None, setoption)
popups['sprintmsgmode'].settitle('Options>Sprinting>Message Delivery')
popups['sprintmsgmode'].addoption(0, 'Popups on the left')
popups['sprintmsgmode'].addoption(1, 'Popups on the bottom-center')
popups['sprintmsgmode'].addoption(2, 'Chat messages')
popups['sprintmsgmode'].addoption('gotosprintmenu', 'Back..')

popups['spawnlook'] = popuplib.easymenu('spawnlook', None, setoption)
popups['spawnlook'].settitle('Options>Spawning>View Enemy Goals')
popups['spawnlook'].addoption(0, 'Off')
popups['spawnlook'].addoption(1, 'On')
popups['spawnlook'].addoption('gotospawnmenu', 'Back..')

def load():
	es.msg('#Green', 'Universal Soccer Script On - by Toph')
	if(es.exists('clientcommand', 'options') != 1):
		cmdlib.registerClientCommand('options', optionssay, 'Shows the player options menu')
	if(es.exists('saycommand', '!options') != 1):
		cmdlib.registerSayCommand('!options', optionssay, 'Shows the player options menu')
	getconfig()
	initvars()
	global isnm
	global commentator
	global deaths
	isnm = 1
	commentator = int(config["Commentator"]["enabled"])
	deaths = int(config["Commentator"]["deaths"])

def unload():
	unloadall()
	savepvars()
	global popups
	for item in popups:
		popups[item].delete()
	popups.clear()
	cmdlib.unregisterClientCommand('options')
	cmdlib.unregisterSayCommand('!options')
	es.msg('#Green', 'Universal Soccer Script Off')

def unloadall():
	if(checkbox in es.addons.TickListeners):
		es.addons.unregisterTickListener(checkbox)
	for script in config['Core']:
		if(int(config['Core'][script]) > 1):
			queue(es.unload, 'soccer/%s%s' % (script.replace('_enabled', '') , config['Core'][script]))
		else:
			queue(es.unload, 'soccer/%s' % script.replace('_enabled', ''))

def es_map_start(event_var):
	global mapname
	global isnm
	isnm = 1
	unloadall()
	mapname = event_var['mapname']
	getcoords(mapname)
	if len(boxes):
		global functions
		functions = {}
	savepvars()

def toload(scriptname):
	return int(config['Core']['%s_enabled' % scriptname])

def player_death(event_var):
	global newround
	newround = 0
	if(es.getlivingplayercount(2) == 0 or es.getlivingplayercount(3) == 0):
		global roundfinished
		roundfinished = 1
	if(commentator == 1 and deaths == 1):
		es.msg('#multi', '#greenPlayer#lightgreen %s #greenhas been injured.' % event_var['es_username'])

def round_start(event_var):
	global roundfinished
	global newround
	roundfinished = 0
	newround = 1
	if(isnm == 1):
		global mapname
		if('ka_soccer' in mapname):
			es.addons.registerTickListener(checkbox)
			es.msg('#Green', 'This server is running Universal Soccer Script v%s by Toph.' % es.server_var['uss_version'])
			for script in config['Core']:
				if(int(config['Core'][script]) == 1):
					queue(es.load, 'soccer/%s' % script.replace('_enabled', ''))
				elif(int(config['Core'][script]) != 0):
					queue(es.load, 'soccer/%s%s' % (script.replace('_enabled', ''), config['Core'][script]))
			if(toload('soccermap') == 1):
				queue(es.doblock, 'soccer/soccermap/doloop')
			if(toload('soccerautoref') == 1 and int(config['Ref']['refmode']) == 1):
				queue(es.doblock, 'soccer/soccerautoref/startptime')
		global isnm
		isnm = 0
	del slayed[:]

def multipleReplace(text, wordDict):
	for key in wordDict:
		text = text.replace(key, wordDict[key])
	return text

def initvars():
	global roundfinished
	global newround
	global players
	global refvars
	global stats
	global slayed
	roundfinished = 0
	newround = 0
	for cvar in config['Core']:
		es.set(cvar, config['Core'][cvar])
		es.makepublic(cvar)
	slayed = []
	players = {}
	refvars = {}
	stats = {}
	stats['@Restricted'] = []
	from os import path
	pvarsfile = es.getAddonPath('soccer') + '/playervars.cpickle'
	if(path.exists(pvarsfile)):
		from cPickle import load
		readpvars = open(pvarsfile, 'r')
		players = load(readpvars)
		readpvars.close()
	wordDic = {
	'soccermod 2008': 'UniversalSoccerScript',
	'soccermod 2009': 'UniversalSoccerScript',
	'soccer mod 2008': 'Universal Soccer Script',
	'soccer mod 2009': 'Universal Soccer Script',
	'soccermod': 'UniversalSoccer',
	'soccer mod': 'Universal Soccer'}
	hostname = es.getString('hostname').lower()
	if('soccer' in hostname and 'mod' in hostname):
		es.set('hostname', multipleReplace(hostname, wordDic))

def restrictstat(name):
	if(name not in stats['@Restricted']):
		stats['@Restricted'].append(name)

def unrestrictstat(name):
	if(name not in stats['@Restricted']):
		return False
	else:
		stats['@Restricted'].remove(name)
		return True

def addsound(sound):
	es.stringtable('downloadables', 'sound/' + sound)

def adddownloads(downloads):
	for download in downloads:
		es.stringtable('downloadables', download)

def slay(userid):
	es.emitsound("player", userid, "weapons/hegrenade/explode3.wav", '1.0', '0.6')
	es.sexec(userid, 'kill')
	if(int(config["Respawn"]["respawnslayed"]) == 0):
		slayed.append(es.getplayersteamid(userid))

def savepvars():
	from cPickle import dump
	writepvars = open(es.getAddonPath('soccer') + '/playervars.cpickle', 'w')
	dump(players, writepvars)
	writepvars.close()

def incstat(steamid, name, stat):
	if(steamid not in stats):
		stats[steamid] = {}
		stats[steamid]['Name'] = name
		stats[steamid][stat] = 1
	elif(stat not in stats[steamid]):
		stats[steamid][stat] = 1
	elif(stats[steamid][stat] != 0):
		stats[steamid][stat] += 1
	else:
		stats[steamid][stat] = 1

def dofire(p1, p2, p3, p4 = "", p5 = ""):
	es.server.cmd('es_xfire %i %s %s [%s] [%s]' % (p1, p2, p3, p4, p5))

def getconfig():
	from configobj import ConfigObj
	global config
	config = ConfigObj(es.server_var['eventscripts_gamedir'] + '/cfg/soccer.ini')

def hook(function, name):
	if name not in functions:
		functions[name] = []
	functions[name].append(function)

def firefunc(name, args):
	if name in functions:
		for func in functions[name]:
			func(args)

def checkbox():
	for userid in es.getUseridList():
		for box in boxes:
			if(str(playerlib.getPlayer(userid).isdead) in str(box.dead) and str(es.getplayerteam(userid)) in str(box.team) and es.getplayerlocation(userid) in box):
				firefunc(box.name, userid)

class Box:
	def __init__(self, dead, team, name, mincoord, maxcoord):
		self.dead = dead
		self.team = team
		self.name = name
		self.mincoord = mincoord
		self.maxcoord = maxcoord
	def __contains__(self, location):
		if(vecmath.isbetweenRect(location, self.mincoord, self.maxcoord)):
			return True

def getcoords(mapname):
	global goalhp
	global goaldisty
	global pbx
	global pbz
	global pbcty
	global pbty
	global newpbcty
	global newpbty
	global halfline
	global goalxm
	global goalxp
	global tgoalym
	global tgoalyp
	global ctgoalym
	global ctgoalyp
	global ballname
	global tgoalviewx
	global tgoalviewy
	global ctgoalviewx
	global ctgoalviewy
	global goalviewz
	global boxes
	global bins
	global g1xm
	global g1xp
	global g1ym
	global g1yp
	global g1zm
	global g1zp
	global g2xm
	global g2xp
	global g2ym
	global g2yp
	global g2zm
	global g2zp
	global bin1telex
	global bin1teley
	global bin2telex
	global bin2teley
	global bin1viewx
	global bin1viewy
	global bin2viewx
	global bin2viewy
	global bin1viewx2
	global bin1viewy2
	global bin2viewx2
	global bin2viewy2
	global b1xm
	global b1xp
	global b2xm
	global b2xp
	global b1ym
	global b1yp
	global b2ym
	global b2yp
	global binym
	global binyp
	global binz
	global binviewz
	global binviewz1
	global binviewz2
	global tspawnxm
	global tspawnxp
	global ctspawnxm
	global ctspawnxp
	global spawnym
	global spawnyp
	global spawnz
	global ttunnelxp
	global ttunnelyp
	global ttunnelxm
	global ttunnelym
	global cttunnelxp
	global cttunnelyp
	global cttunnelxm
	global cttunnelym
	boxes = []
	soccerautoref_enabled = int(config["Core"]["soccerautoref_enabled"])
	soccergoalie_enabled = int(config["Core"]["soccergoalie_enabled"])
	soccergoalslay_enabled = int(config["Core"]["soccergoalslay_enabled"])
	soccerstats_enabled = int(config["Core"]["soccerstats_enabled"])
	healthmode = int(config["Health"]["healthmode"])
	spawnmode = int(config["Respawn"]["spawnmode"])
	if("ka_soccer_20" in mapname):
		if("2007" in mapname):
			goalhp = 300
			ballname = "football"
			if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
				goaldisty = 320
				pbx = 0
				pbz = 82
				pbty = 1370
				pbcty = -1370
			if(healthmode > 2):
				tgoalviewx = 4.101076
				tgoalviewy = -1396.985474
				ctgoalviewx = -4.101076
				ctgoalviewy = 1787.664185
				goalviewz = 185
				#if(spawnmode < 3):
				if(1):
					bins = 2
					g1xm = -2382
					g1xp = -1952
					g1ym = -353
					g1yp = 307
					g1zm = 646
					g1zp = 997
					g2xm = 1972
					g2xp = 2476
					g2ym = -274
					g2yp = 485
					g2zm = 604
					g2zp = 957
					bin1telex = -2274.375977
					bin1teley = -158.134750
					bin2telex = 2274.375977
					bin2teley = 158.134750
					bin1viewx = -2240.031250
					bin1viewy = -12.799352
					bin2viewx = 2240.031250
					bin2viewy = 12.799352
					b1xm = -2276
					b1xp = -2083
					b2xm = 2083
					b2xp = 2276
					b1ym = 0
					b1yp = 0
					b2ym = 0
					b2yp = 0
					binym = -209
					binyp = 212
					binz = 768.031250
					binviewz = 759.031250
					binviewz1 = 0
					binviewz2 = 0
					tspawnxm = -1545
					tspawnxp = -1314
					ctspawnxm = 1314
					ctspawnxp = 1545
					spawnym = -163
					spawnyp = 163
					spawnz = 120
					ttunnelxp = -1226.581299
					ttunnelyp = 340.507599
					ttunnelxm = -3359.517822
					ttunnelym = -340.507599
					cttunnelxp = 3359.517822
					cttunnelyp = 340.507599
					cttunnelxm = 1226.581299
					cttunnelym = -340.507599
			if(soccergoalie_enabled != 0 or soccerstats_enabled == 1 or healthmode > 2):
				halfline = 0
				goalxm = -675
				goalxp = 675
				tgoalym = 1181
				tgoalyp = 1964
				ctgoalym = -1964
				ctgoalyp = -1181
			if(soccergoalie_enabled == 1):
				boxes.append(Box(0, 23, 'thefield', (-1262.968750,-2030.968750,64.031250), (1262.968750,2030.968750,64.031250)))
				boxes.append(Box(0, 2, 'goalbox1', (-383,1539,0), (383,1964,5000)))
				boxes.append(Box(0, 3, 'goalbox2', (-383,-1964,0), (383,-1539,5000)))
			if(soccergoalslay_enabled != 0):
				boxes.append(Box(0, 23, 'goaltop1', (150,1817,188), (-151,1785,192)))
				boxes.append(Box(0, 23, 'goaltop2', (-150,-1784,192), (151,-1815,188)))
		elif("_sansiro" in mapname):
			goalhp = 250
			ballname = "ballon"
			if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
				goaldisty = 320
				pbx = 0
				pbz = 150
				pbty = 1012.729736
				pbcty = -1012.729736
			if(healthmode > 2):
				tgoalviewx = 0
				tgoalviewy = -1396.985474
				ctgoalviewx = 0
				ctgoalviewy = 1396.985474
				goalviewz = 105.031250
				#if(spawnmode < 3):
				if(1):
					bins = 0
					g1xp = 8008
					g1yp = 3602
					g1zp = 1863
					g1xm = 7594
					g1ym = 3103
					g1zm = 1450
					g2xp = 8008
					g2yp = 3602
					g2xm = 7594
					g2ym = 3103
					g2zm = 1450
					g2zp = 1863
					bin1telex = 7785.031250
					bin1teley = 3327.031250
					bin2telex = 7785.031250
					bin2teley = 3327.031250
					bin1viewx = 7914.031250
					bin1viewy = 3428.031250
					bin2viewx = 7914.031250
					bin2viewy = 3428.031250
					bin1viewx2 = 7840.031250
					bin1viewy2 = 3377.031250
					bin2viewx2 = 7840.031250
					bin2viewy2 = 3377.031250
					binviewz = 0
					binviewz1 = 1491.031250
					binviewz2 = 1581.031250
					b1xm = 7730
					b1xp = 7903
					b2xm = 7730
					b2xp = 7903
					b1ym = 0
					b1yp = 0
					b2ym = 0
					b2yp = 0
					binym = 3191
					binyp = 3474
					binz = 1585.031250
					tspawnxm = 4631
					tspawnxp = 4848
					ctspawnxm = 7443
					ctspawnxp = 7656
					spawnym = 3250
					spawnyp = 3411
					spawnz = 1076
					ttunnelxp = 7958
					ttunnelyp = 3461
					ttunnelxm = 7385
					ttunnelym = 3185
					cttunnelxp = 4935
					cttunnelyp = 3461
					cttunnelxm = 4250
					cttunnelym = 3185
			#if(soccergoalie_enabled != 0 or soccerstats_enabled == 1 or healthmode > 2):
				#halfline = 3328
				#goalxm = 5538
				#goalxp = 6746
				#tgoalym = 4162
				#tgoalyp = 4772
				#ctgoalym = 1877
				#ctgoalyp = 2494
			#if(soccergoalie_enabled == 1):
				#boxes.append(Box(0, 23, 'thefield', (4880.031250, 1680.005737, 1024.031250), (7407.968750, 4975.968750, 1024.031250)))
				#boxes.append(Box(0, 2, 'goalbox1', (5830, 4520, 0), (6454, 4772, 5000)))
				#boxes.append(Box(0, 3, 'goalbox2', (5830, 1877, 0), (6454, 2136, 5000)))
			#if(soccergoalslay_enabled != 0):
				#boxes.append(Box(0, 23, 'goaltop1', (5998, 4705, 1125), (6284, 4772, 1130)))
				#boxes.append(Box(0, 23, 'goaltop2', (5998, 1877, 1125), (6284, 1951, 1130)))
		else:
			goalhp = 250
			ballname = "ballon"
			if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
				goaldisty = 320
				pbx = 6144
				pbz = 1041
				pbty = 4344
				pbcty = 2312
			if(healthmode > 2):
				tgoalviewx = 6148.051270
				tgoalviewy = 1935.321167
				ctgoalviewx = 6148.051270
				ctgoalviewy = 4717.780762
				goalviewz = 1129.031250
				#if(spawnmode < 3):
				if(1):
					bins = 1
					g1xp = 8008
					g1yp = 3602
					g1zp = 1863
					g1xm = 7594
					g1ym = 3103
					g1zm = 1450
					g2xp = 8008
					g2yp = 3602
					g2xm = 7594
					g2ym = 3103
					g2zm = 1450
					g2zp = 1863
					bin1telex = 7785.031250
					bin1teley = 3327.031250
					bin2telex = 7785.031250
					bin2teley = 3327.031250
					bin1viewx = 7914.031250
					bin1viewy = 3428.031250
					bin2viewx = 7914.031250
					bin2viewy = 3428.031250
					bin1viewx2 = 7840.031250
					bin1viewy2 = 3377.031250
					bin2viewx2 = 7840.031250
					bin2viewy2 = 3377.031250
					binviewz = 0
					binviewz1 = 1491.031250
					binviewz2 = 1581.031250
					b1xm = 7730
					b1xp = 7903
					b2xm = 7730
					b2xp = 7903
					b1ym = 0
					b1yp = 0
					b2ym = 0
					b2yp = 0
					binym = 3191
					binyp = 3474
					binz = 1585.031250
					tspawnxm = 7443
					tspawnxp = 7656
					ctspawnxm = 4631
					ctspawnxp = 4848
					spawnym = 3250
					spawnyp = 3411
					spawnz = 1076
					ttunnelxp = 7958
					ttunnelyp = 3461
					ttunnelxm = 7385
					ttunnelym = 3185
					cttunnelxp = 4935
					cttunnelyp = 3461
					cttunnelxm = 4250
					cttunnelym = 3185
			if(soccergoalie_enabled != 0 or soccerstats_enabled == 1 or healthmode > 2):
				halfline = 3328
				goalxm = 5538
				goalxp = 6746
				tgoalym = 4162
				tgoalyp = 4772
				ctgoalym = 1877
				ctgoalyp = 2494
			if(soccergoalie_enabled == 1):
				boxes.append(Box(0, 23, 'thefield', (4880.031250, 1680.005737, 1024.031250), (7407.968750, 4975.968750, 1024.031250)))
				boxes.append(Box(0, 2, 'goalbox1', (5830, 4520, 0), (6454, 4772, 5000)))
				boxes.append(Box(0, 3, 'goalbox2', (5830, 1877, 0), (6454, 2136, 5000)))
			if(soccergoalslay_enabled != 0):
				boxes.append(Box(0, 23, 'goaltop1', (5998, 4705, 1125), (6284, 4772, 1130)))
				boxes.append(Box(0, 23, 'goaltop2', (5998, 1877, 1125), (6284, 1951, 1130)))
	elif("_acssl_2010" in mapname):
		goalhp = 5000
		ballname = "ball"
		if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
			goaldisty = 320
			pbx = 6144
			pbz = 1041
			pbty = 4344
			pbcty = 2312
		if(healthmode > 2):
			tgoalviewx = 6148.051270
			tgoalviewy = 1935.321167
			ctgoalviewx = 6148.051270
			ctgoalviewy = 4717.780762
			goalviewz = 1129.031250
			#if(spawnmode < 3):
			if(1):
				bins = 0
				g1xp = 8008
				g1yp = 3602
				g1zp = 1863
				g1xm = 7594
				g1ym = 3103
				g1zm = 1450
				g2xp = 8008
				g2yp = 3602
				g2xm = 7594
				g2ym = 3103
				g2zm = 1450
				g2zp = 1863
				bin1telex = 7785.031250
				bin1teley = 3327.031250
				bin2telex = 7785.031250
				bin2teley = 3327.031250
				bin1viewx = 7914.031250
				bin1viewy = 3428.031250
				bin2viewx = 7914.031250
				bin2viewy = 3428.031250
				bin1viewx2 = 7840.031250
				bin1viewy2 = 3377.031250
				bin2viewx2 = 7840.031250
				bin2viewy2 = 3377.031250
				binviewz1 = 1491.031250
				binviewz2 = 1581.031250
				b1xm = 7730
				b1xp = 7903
				b2xm = 7730
				b2xp = 7903
				b1ym = 0
				b1yp = 0
				b2ym = 0
				b2yp = 0
				binym = 3191
				binyp = 3474
				binz = 1585.031250
				tspawnxm = 7443
				tspawnxp = 7656
				ctspawnxm = 4631
				ctspawnxp = 4848
				spawnym = 3250
				spawnyp = 3411
				spawnz = 1076
				ttunnelxp = 7958
				ttunnelyp = 3461
				ttunnelxm = 7385
				ttunnelym = 3185
				cttunnelxp = 4935
				cttunnelyp = 3461
				cttunnelxm = 4250
				cttunnelym = 3185
		if(soccergoalie_enabled != 0 or soccerstats_enabled == 1 or healthmode > 2):
			halfline = 3328
			goalxm = 5538
			goalxp = 6746
			tgoalym = 4162
			tgoalyp = 4772
			ctgoalym = 1877
			ctgoalyp = 2494
		if(soccergoalie_enabled == 1):
			boxes.append(Box(0, 23, 'thefield', (4880.031250, 1680.005737, 1024.031250), (7407.968750, 4975.968750, 1024.031250)))
			boxes.append(Box(0, 2, 'goalbox1', (5830, 4520, 0), (6454, 4772, 5000)))
			boxes.append(Box(0, 3, 'goalbox2', (5830, 1877, 0), (6454, 2136, 5000)))
		if(soccergoalslay_enabled != 0):
			boxes.append(Box(0, 23, 'goaltop1', (5998, 4705, 1125), (6284, 4772, 1130)))
			boxes.append(Box(0, 23, 'goaltop2', (5998, 1877, 1125), (6284, 1951, 1130)))
	else:
		goalhp = 250
		ballname = "ballon"
		if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
			goaldisty = 320
			pbx = 6144
			pbz = 1041
			pbty = 4344
			pbcty = 2312
		if(healthmode > 2):
			tgoalviewx = 0
			tgoalviewy = -1389.929199
			ctgoalviewx = 0
			ctgoalviewy = 1389.929199
			goalviewz = 105.031250
			#if(spawnmode < 3):
			if(1):
				bins = 0
				g1xp = 221
				g1yp = 2972
				g1zp = 693
				g1xm = -221
				g1ym = 2398
				g1zm = 388
				g2xp = 221
				g2yp = -2398
				g2xm = -221
				g2ym = -2972
				g2zm = 388
				g2zp = 693
				bin1telex = 0
				bin1teley = 0
				bin2telex = 0
				bin2teley = 0
				bin1viewx = 0
				bin1viewy = 0
				bin2viewx = 0
				bin2viewy = 0
				bin1viewx2 = 0
				bin1viewy2 = 0
				bin2viewx2 = 0
				bin2viewy2 = 0
				binviewz1 = 0
				binviewz2 = 0
				b1xm = -149
				b1xp = 145
				b2xm = -149
				b2xp = 145
				b1ym = 2481
				b1yp = 2867
				b2ym = -2867
				b2yp = -2481
				binym = 0
				binyp = 0
				binz = 560.031250
				tspawnxm = 1328
				tspawnxp = 1511
				ctspawnxm = -1511
				ctspawnxp = -1328
				spawnym = -252
				spawnyp = 252
				spawnz = 60
				ttunnelxp = 0
				ttunnelyp = 0
				ttunnelxm = 0
				ttunnelym = 0
				cttunnelxp = 0
				cttunnelyp = 0
				cttunnelxm = 0
				cttunnelym = 0
		if(soccergoalie_enabled != 0 or soccerstats_enabled == 1 or healthmode > 2):
			halfline = 0
			goalxm = -602
			goalxp = 602
			tgoalym = 827
			tgoalyp = 1539
			ctgoalym = -1539
			ctgoalyp = -827
		if(soccergoalie_enabled == 1):
			boxes.append(Box(0, 23, 'thefield', (-1263.968750, -1647.968750, 0.031250), (1263.968750, 1647.968750, 57.624115)))
			boxes.append(Box(0, 2, 'goalbox1', (-310, 1185, 0), (310, 1539, 5000)))
			boxes.append(Box(0, 3, 'goalbox2', (-310, -1539, 0), (310, -1185, 5000)))
		if(soccergoalslay_enabled != 0):
			boxes.append(Box(0, 23, 'goaltop1', (142, 1453, 102), (-146, 1370, 106)))
			boxes.append(Box(0, 23, 'goaltop2', (-146, -1453, 102), (142, -1370, 106)))
	newpbcty = pbcty
	newpbty = pbty
	if(pbcty < pbty):
		newpbcty -= goaldisty
		newpbty += goaldisty
	else:
		newpbcty += goaldisty
		newpbty -= goaldisty