import es
import time
import gamethread
import random
import soccer.soccer as soccerlib
import playerlib
import nativetools
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Respawn Script"
info.version = soccerlib.info.version
info.basename = "soccerrespawn"
info.author = "chrismrulz"

count = 0
spawnmode = int(soccerlib.config["Respawn"]["spawnmode"])
spawneditrestart = int(soccerlib.config["Respawn"]["spawneditrestart"])
bintime = time.strptime(soccerlib.config["Respawn"]["bintime"], "%M:%S")
bintime = int(time.strftime('%M', bintime)) * 60 + int(time.strftime('%S', bintime))
msgtime = time.strptime(soccerlib.config["Respawn"]["msgtime"], "%M:%S")
msgtime = int(time.strftime('%M', msgtime)) * 60 + int(time.strftime('%S',msgtime))
viewenemygoals = int(soccerlib.config["Respawn"]["viewenemygoals"])
ctgoalviewx = soccerlib.ctgoalviewx
ctgoalviewy = soccerlib.ctgoalviewy
tgoalviewx = soccerlib.tgoalviewx
tgoalviewy = soccerlib.tgoalviewy
goalviewz = soccerlib.goalviewz
goalhp = soccerlib.goalhp
bins = soccerlib.bins
b1xm = soccerlib.b1xm
b1xp = soccerlib.b1xp
b1ym = soccerlib.b1ym
b1yp = soccerlib.b1yp
b2xm = soccerlib.b2xm
b2xp = soccerlib.b2xp
b2ym = soccerlib.b2ym
b2yp = soccerlib.b2yp
binym = soccerlib.binym
binyp = soccerlib.binyp
binz = soccerlib.binz
bin1telex = soccerlib.bin1telex
bin1teley = soccerlib.bin1teley
bin1viewx = soccerlib.bin1viewx
bin1viewx2 = soccerlib.bin1viewx2
bin1viewy = soccerlib.bin1viewy
bin1viewy2 = soccerlib.bin1viewy2
bin2telex = soccerlib.bin2telex
bin2teley = soccerlib.bin2teley
bin2viewx = soccerlib.bin2viewx
bin2viewx2 = soccerlib.bin2viewx2
bin2viewy = soccerlib.bin2viewy
bin2viewy2 = soccerlib.bin2viewy2
binviewz = soccerlib.binviewz
binviewz1 = soccerlib.binviewz1
binviewz2 = soccerlib.binviewz2
tspawnxm = soccerlib.tspawnxm
tspawnxp = soccerlib.tspawnxp
ctspawnxm = soccerlib.ctspawnxm
ctspawnxp = soccerlib.ctspawnxp
spawnym = soccerlib.spawnym
spawnyp = soccerlib.spawnyp
spawnz = soccerlib.spawnz

def load():
	es.msg('#Green','Soccer Respawn Script On - by Toph')

def unload():
	es.msg('#Green','Soccer Respawn Script Off')

def getlook(steamid):
	if(steamid not in soccerlib.players):
		return viewenemygoals
	else:
		if('spawnlook' not in soccerlib.players[steamid]):
			return viewenemygoals
		else:
			return soccerlib.players[steamid]['spawnlook']

def round_start(event_var):
	global nr_tt
	nr_tt = time.time() + bintime
	global binblocked
	global bin2blocked
	binblocked = 0
	bin2blocked = 0
	if(spawnmode == 2 and es.getlivingplayercount() != 0):
		if(count == 0):
			global spawni
			global count
			spawni = 0
			count = 1
			freezeall()
			gamethread.delayed(1, removespawn, (random.randint(b1xm, b1xp), random.randint(binym, binyp), binz))
		starttele()

def freezeall(on = True):
	for ply in playerlib.getPlayerList('#alive'):
		if(on):
			ply.freeze = 1
		else:
			ply.freeze = 0

def inbin(userid, team, steamid):
	dotele(userid, team)
	gamethread.delayed(bintime, outbin, (userid, steamid, team))
	gamethread.delayed(bintime, dolook, (steamid, userid, team))

def dotele(userid, team):
	es.menu(msgtime, userid, 'You have been injured. You will come back on the field in %s seconds.' % bintime)
	player = playerlib.getPlayer(userid)
	if(bins == 0):
		if(team == 2):
			player.setLocation([random.randint(b1xm, b1xp), random.randint(b1ym, b1yp), binz])
		elif(team == 3):
			player.setLocation([random.randint(b2xm, b2xp), random.randint(b2ym, b2yp), binz])
	elif(team == 2):
		if(binblocked == 0):
			player.freeze = 1
			player.setLocation([bin1telex, bin1teley, binz])
			if(bins == 2):
				player.viewCoord([bin1viewx, bin1viewy, binviewz1])
				es.prop_dynamic_create(userid, 'props_debris/wall001a_Base.mdl')
				player.viewCoord([bin1viewx2, bin1viewy2, binviewz2])
			else:
				player.viewCoord([bin1viewx, bin1viewy, binviewz])
			es.prop_dynamic_create(userid, 'props_debris/wall001a_Base.mdl')
			player.freeze = 0
			# todo: set the entity color here
			global binblocked
			binblocked = 1
		else:
			player.setLocation([random.randint(b1xm, b1xp), random.randint(binym, binyp), binz])
	elif(team == 3):
		if(binblocked == 0 or bin2blocked == 0):
			player.freeze = 1
			player.setLocation([bin2telex, bin2teley, binz])
			if(bins == 2):
				player.viewCoord([bin2viewx, bin2viewy, binviewz1])
				es.prop_dynamic_create(userid, 'props_debris/wall001a_Base.mdl')
				player.viewCoord([bin2viewx2, bin2viewy2, binviewz2])
			else:
				player.viewCoord([bin2viewx, bin2viewy, binviewz])
			es.prop_dynamic_create(userid, 'props_debris/wall001a_Base.mdl')
			player.freeze = 0
			# todo: set the entity color here
			global binblocked
			binblocked = 1
		else:
			player.setLocation([random.randint(b2xm, b2xp), random.randint(binym, binyp), binz])

def openbin():
	es.remove('prop_dynamic')
	gamethread.delayed(.4, es.remove, 'prop_dynamic')
	gamethread.delayed(2, es.set, ('binblocked', 0))

def outbin(userid, steamid, team = 0):
	nrt_time = time.time()
	if(nrt_time >= nr_tt):
		if(soccerlib.newround == 0 and soccerlib.roundfinished != 1):
			if(spawnmode == 3):
				nativetools.spawnPlayer(userid)
			else:
				tunneltele(userid, steamid, team)
			if(getlook(steamid) == 1):
				es.menu(msgtime, userid, 'You are now back on the field and facing your opponent goals.')
			else:
				es.menu(msgtime, userid, 'You are now back on the field.')

def tunneltele(userid, steamid, team):
	player = playerlib.getPlayer(userid)
	player.freeze = 1
	if(team == 2):
		player.setLocation([random.randint(tspawnxm, tspawnxp), random.randint(spawnym, spawnyp), spawnz])
	elif(team == 3):
		player.setLocation([random.randint(ctspawnxm, ctspawnxp), random.randint(spawnym, spawnyp), spawnz])
	player.freeze = 0

def removespawn(x, y, z):
	global spawnPoints
	spawnPoints = {}
	spawnTeams = ['info_player_terrorist', 'info_player_counterterrorist']
	for spawnTeam in spawnTeams:
		for index in es.createentitylist(spawnTeam):
			spawnPoints[index] = [spawnTeam, es.getindexprop(index, 'CBaseEntity.m_vecOrigin'), es.getindexprop(index, 'CBaseEntity.m_angRotation')]
			gamethread.delayed(spawni, es.server.cmd, 'es_xremove %s' % spawnTeam)
			global spawni
			spawni += 0.2
	es.msg('#multi', '#lightgreen[Universal Soccer Script] #greenEditing check points... This will take approximately %s seconds.' % spawni)
	gamethread.delayed(spawni, insertspawn, (x, y, z))
	if(spawneditrestart == 1):
		gamethread.delayed(spawni, es.msg, ('#multi', '#lightgreen[Universal Soccer Script] #greenCheck points edited. Restarting round...'))
		gamethread.delayed(spawni, es.server.cmd, 'mp_restartgame 1')
	else:
		gamethread.delayed(spawni, es.msg, ('#multi', '#lightgreen[Universal Soccer Script] #greenCheck points edited. Unfreezing players...'))
		gamethread.delayed(spawni, freezeall, False)

def insertspawn(x, y, z):
	rp = random.choice(playerlib.getUseridList('#alive'))
	for index in spawnPoints:
		es.server.cmd('es_xgive %s %s' % (rp, spawnPoints[index][0]))
		lindex = int(es.ServerVar('eventscripts_lastgive'))
		es.setindexprop(lindex, 'CBaseEntity.m_vecOrigin', '%s,%s,%s' % (x, y, z))
		es.setindexprop(lindex, 'CBaseEntity.m_angRotation', spawnPoints[index][2])

def starttele():
	plistt = playerlib.getUseridList('#t')
	plistct = playerlib.getUseridList('#ct')
	for index in spawnPoints:
		if(spawnPoints[index][0] == 'info_player_terrorist'):
			if(len(plistt) != 0):
				randid = random.choice(plistt)
				plistt.remove(randid)
		elif(len(plistct) != 0):
			randid = random.choice(plistct)
			plistct.remove(randid)
		player = playerlib.getPlayer(randid)
		player.setLocation(spawnPoints[index][1].split(','))
		es.setplayerprop(randid, 'CBaseEntity.m_angRotation', spawnPoints[index][2])

def player_death(event_var):
	if(spawnmode != 1 and es.getlivingplayercount(2) != 0 and es.getlivingplayercount(3) != 0 and event_var['es_steamid'] not in soccerlib.slayed):
		userid = int(event_var['userid'])
		es.menu((bintime - 1), userid, 'You have been injured. You will come back on the field in %s seconds.' % bintime)
		if(spawnmode == 2):
			nativetools.spawnPlayer(userid)
			gamethread.delayed(bintime, outbin, (userid, event_var['es_steamid'], int(event_var['es_userteam'])))
			gamethread.delayed(bintime, dolook, (event_var['es_steamid'], userid, int(event_var['es_userteam'])))
		else:
			gamethread.delayed(bintime, outbin, (userid, event_var['es_steamid']))

def player_hurt(event_var):
	if(spawnmode == 1):
		userid = int(event_var['userid'])
		if(int(event_var['dmg_health']) == goalhp):
			es.sexec(userid, 'kill')
		else:
			playerlib.getPlayer(userid).health += int(event_var['dmg_health'])
		if(int(event_var['dmg_health']) > goalhp and soccerlib.roundfinished != 1):
			inbin(userid, int(event_var['es_userteam']), event_var['es_steamid'])

def player_spawn(event_var):
	userid = int(event_var['userid'])
	if(spawnmode == 1):
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 1274)
	dolook(event_var['es_steamid'], userid, int(event_var['es_userteam']))

def dolook(steamid, userid, team):
	if(getlook(steamid) == 1):
		if(team == 2):
			playerlib.getPlayer(userid).viewCoord([tgoalviewx, tgoalviewy, goalviewz])
		elif(team == 3):
			playerlib.getPlayer(userid).viewCoord([ctgoalviewx, ctgoalviewy, goalviewz])